<!DOCTYPE html>
<html>
  <head>
    <title>list order</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />

    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- Import them style bootstrap cho datatable -->
    <link
      rel="stylesheet"
      href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css"
    />

    <!-- Import Datatable sau jquery -->
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

    <!-- Import awesome-->
    <link
      rel="stylesheet"
      href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.3.0/css/all.min.css"
    />
  </head>

  <body>
    <div class="container-fluid">
      <div class="text-center mt-2 mb-2">
        <h2>Manage Order</h2>
      </div>

      <div class="row form-group py-3 bg-light rounded">
        <label class="col-sm-2 col-form-label text-center"
          ><b>Status order</b></label
        >
        <div class="col-sm-3">
          <select id="select-status" class="form-control"></select>
        </div>
        <label class="col-sm-2 col-form-label text-center"
          ><b>Type pizza</b></label
        >
        <div class="col-sm-3">
          <select id="select-typePizza" class="form-control"></select>
        </div>
        <div class="col-sm-2">
          <button id="btn-filter-order" class="btn btn-info w-100">
            Filter
          </button>
        </div>
      </div>
      <div class="row form-group">
        <button class="btn btn-success" id="add-infor-order">
          <i class="fa-regular fa-plus"></i> &nbsp;Add
        </button>
      </div>
    </div>

    <div class="container-fluid">
      <table
        class="table table-bordered table-striped table-hover"
        id="order-table"
      >
        <thead class="bg-dark text-white">
          <tr>
            <th>No.</th>
            <th>Order Code</th>
            <th>Size</th>
            <th>Pizza Type</th>
            <th>Drink</th>
            <th>Price</th>
            <th>Customer Name</th>
            <th>Phone</th>
            <th>Status</th>
            <th>Action</th>
          </tr>
        </thead>
      </table>
    </div>
    <!-- Vùng Modal -->
    <!-- Create course modal -->
    <div id="create-order-modal" class="modal fade" tabindex="-1">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">Create New Order</h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <form>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="input-create-order-code">Order code</label>
                </div>
                <div class="col-sm-9">
                  <input
                    type="text"
                    id="input-create-order-code"
                    name="ordercodes"
                    placeholder="...."
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="create-select-combo">Pizza Size</label>
                </div>
                <div class="col-sm-9">
                  <select id="create-select-combo" class="form-control">
                    <option value="all">--All--</option>
                  </select>
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="input-size-cm">Size</label>
                </div>
                <div class="col-sm-9">
                  <input
                    type="text"
                    id="create-size-cm"
                    name="size"
                    placeholder="..."
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="input-size-cm">Grilled-ribs</label>
                </div>
                <div class="col-sm-9">
                  <input
                    type="text"
                    id="create-ribs"
                    name="grillribs"
                    placeholder="..."
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="create-salad">Salad</label>
                </div>
                <div class="col-sm-9">
                  <input
                    type="text"
                    id="create-salad"
                    name="create-salad"
                    placeholder="..."
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="create-pizza-type">Pizza type</label>
                </div>
                <div class="col-sm-9">
                  <input
                    type="text"
                    id="create-pizza-type"
                    name="create-pizza-type"
                    placeholder="..."
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="create-voucher">Voucher</label>
                </div>
                <div class="col-sm-9">
                  <input
                    type="text"
                    id="create-voucher"
                    name="create-pizza-type"
                    placeholder="..."
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="create-price">Price</label>
                </div>
                <div class="col-sm-9">
                  <input
                    type="text"
                    id="create-price"
                    name="create-price"
                    placeholder="..."
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="create-discount">Discount</label>
                </div>
                <div class="col-sm-9">
                  <input
                    type="text"
                    id="create-discount"
                    name="create-discount"
                    placeholder="..."
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="create-drink">Drink</label>
                </div>
                <div class="col-sm-9">
                  <select id="create-drink" class="form-control">
                    <option value="all">--All--</option>
                  </select>
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="create-amount">Amount</label>
                </div>
                <div class="col-sm-9">
                  <input
                    type="text"
                    id="create-amount"
                    name="create-amount"
                    placeholder="..."
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="create-fullname">Full name</label>
                </div>
                <div class="col-sm-9">
                  <input
                    type="text"
                    id="create-fullname"
                    name="create-fullname"
                    placeholder="..."
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="create-email">Email</label>
                </div>
                <div class="col-sm-9">
                  <input
                    type="text"
                    id="create-email"
                    name="create-email"
                    placeholder="..."
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="create-phone">Phone</label>
                </div>
                <div class="col-sm-9">
                  <input
                    type="text"
                    id="create-phone"
                    name="create-phone"
                    placeholder="..."
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="create-phone">Address</label>
                </div>
                <div class="col-sm-9">
                  <input
                    type="text"
                    id="create-address"
                    name="create-address"
                    placeholder="..."
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="create-message">Message</label>
                </div>
                <div class="col-sm-9">
                  <input
                    type="text"
                    id="create-message"
                    name="create-message"
                    placeholder="..."
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="create-order-date">Order Date</label>
                </div>
                <div class="col-sm-9">
                  <input
                    type="text"
                    id="create-order-date"
                    name="create-order-date"
                    placeholder="..."
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="create-update-date">Update Date</label>
                </div>
                <div class="col-sm-9">
                  <input
                    type="text"
                    id="create-update-date"
                    name="create-update-date"
                    placeholder="..."
                    class="form-control"
                  />
                </div>
              </div>
            </form>
          </div>
          <div class="modal-footer">
            <div class="row form-group">
              <div class="col-sm-6">
                <button class="btn btn-primary" id="btn-create-confirm">
                  Confirm
                </button>
              </div>
              <div class="col-sm-6">
                <button class="btn btn-danger" id="btn-create-close">
                  Close
                </button>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- edit order modal -->
    <div id="edit-order-modal" class="modal fade" tabindex="-1">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">Order edits</h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <form>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="input-edit-order-code">Order code</label>
                </div>
                <div class="col-sm-9">
                  <input
                    type="text"
                    id="input-edit-order-code"
                    name="ordercodes"
                    placeholder="...."
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="edit-select-combo">Pizza Size</label>
                </div>
                <div class="col-sm-9">
                  <select id="edit-select-combo" class="form-control">
                    <option value="all">--All--</option>
                  </select>
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="input-size-cm">Size</label>
                </div>
                <div class="col-sm-9">
                  <input
                    type="text"
                    id="edit-size-cm"
                    name="size"
                    placeholder="..."
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="input-size-cm">Grilled-ribs</label>
                </div>
                <div class="col-sm-9">
                  <input
                    type="text"
                    id="edit-ribs"
                    name="grillribs"
                    placeholder="..."
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="edit-salad">Salad</label>
                </div>
                <div class="col-sm-9">
                  <input
                    type="text"
                    id="edit-salad"
                    name="edit-salad"
                    placeholder="..."
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="edit-pizza-type">Pizza type</label>
                </div>
                <div class="col-sm-9">
                  <input
                    type="text"
                    id="edit-pizza-type"
                    name="edit-pizza-type"
                    placeholder="..."
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="edit-voucher">Voucher</label>
                </div>
                <div class="col-sm-9">
                  <input
                    type="text"
                    id="edit-voucher"
                    name="edit-pizza-type"
                    placeholder="..."
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="edit-price">Price</label>
                </div>
                <div class="col-sm-9">
                  <input
                    type="text"
                    id="edit-price"
                    name="edit-price"
                    placeholder="..."
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="edit-discount">Discount</label>
                </div>
                <div class="col-sm-9">
                  <input
                    type="text"
                    id="edit-discount"
                    name="edit-discount"
                    placeholder="..."
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="edit-drink">Drink</label>
                </div>
                <div class="col-sm-9">
                  <select id="edit-drink" class="form-control">
                    <option value="all">--All--</option>
                  </select>
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="edit-amount">Amount</label>
                </div>
                <div class="col-sm-9">
                  <input
                    type="text"
                    id="edit-amount"
                    name="edit-amount"
                    placeholder="..."
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="edit-fullname">Full name</label>
                </div>
                <div class="col-sm-9">
                  <input
                    type="text"
                    id="edit-fullname"
                    name="edit-fullname"
                    placeholder="..."
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="edit-email">Email</label>
                </div>
                <div class="col-sm-9">
                  <input
                    type="text"
                    id="edit-email"
                    name="edit-email"
                    placeholder="..."
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="edit-phone">Phone</label>
                </div>
                <div class="col-sm-9">
                  <input
                    type="text"
                    id="edit-phone"
                    name="edit-phone"
                    placeholder="..."
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="edit-phone">Address</label>
                </div>
                <div class="col-sm-9">
                  <input
                    type="text"
                    id="edit-address"
                    name="edit-address"
                    placeholder="..."
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="edit-messag">Message</label>
                </div>
                <div class="col-sm-9">
                  <input
                    type="text"
                    id="edit-message"
                    name="edit-message"
                    placeholder="..."
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="dedit-order-date">Order Date</label>
                </div>
                <div class="col-sm-9">
                  <input
                    type="text"
                    id="edit-order-date"
                    name="edit-order-date"
                    placeholder="..."
                    class="form-control"
                  />
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-3">
                  <label for="dedit-update-date">Update Date</label>
                </div>
                <div class="col-sm-9">
                  <input
                    type="text"
                    id="edit-update-date"
                    name="edit-update-date"
                    placeholder="..."
                    class="form-control"
                  />
                </div>
              </div>
            </form>
          </div>
          <div class="modal-footer">
            <div class="row form-group">
              <div class="col-sm-6">
                <button class="btn btn-primary" id="btn-edit-confirm">
                  Confirm
                </button>
              </div>
              <div class="col-sm-6">
                <button class="btn btn-danger" id="btn-edit-cancel">
                  Cancel
                </button>
              </div>
            </div>
            <div class="row form-group">
              <button
                class="btn btn-secondary"
                id="btn-close"
                data-dismiss="modal"
              >
                Close
              </button>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- delete grade modal -->

    <div id="delete-order-modal" class="modal fade" tabindex="-1">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">
              Delete Information Order
            </h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <p>Do you sure delete information order?</p>
          </div>
          <div class="modal-footer">
            <div class="row form-group">
              <div class="col-sm-6">
                <button class="btn btn-primary" id="btn-delete-confirm">
                  Confirm
                </button>
              </div>
              <div class="col-sm-6">
                <button class="btn btn-danger" id="btn-delete-cancel">
                  Cancel
                </button>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>

    <script>
      "use strict";
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      // mảng orders
      var gOrderObjects = [];
      var gStt = 0;
      var gOrderCode;
      var gId;
      var gPizzaSize = ["S", "M", "L"];

      const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";

      // mảng pizza Type
      var gPizzaType = [
        {
          typeId: "Seafood",
          typeName: "Seafood",
        },
        {
          typeId: "HAWAII",
          typeName: "HAWAII",
        },
        {
          typeId: "Bacon",
          typeName: "Bacon",
        },
      ];

      // mảng status
      var gStatus = [
        {
          id: "open",
          name: "Open",
        },
        {
          id: "confirmed",
          name: "Confirmed",
        },
        {
          id: "cancel",
          name: "Cancel",
        },
      ];

      const ARRAY_NAME_COL = [
        "Stt",
        "orderCode",
        "kichCo",
        "loaiPizza",
        "idLoaiNuocUong",
        "thanhTien",
        "hoTen",
        "soDienThoai",
        "trangThai",
        "action",
      ];
      //khai báo các cột
      const gCOL_NO = 0;
      const gCOL_ORDERCODE = 1;
      const gCOL_COMBO = 2;
      const gCOL_PIZZA_ID = 3;
      const gCOL_DRINK_ID = 4;
      const gCOL_PRICE = 5;
      const gCOL_CUSTOMER_NAME = 6;
      const gCOL_PHONE = 7;
      const gCOL_STATUS = 8;
      const gCOL_ACTION = 9;
      var gSTT = 0;

      // khởi tạo datatable  - chưa có data
      var gOrderTable = $("#order-table").DataTable({
        columns: [
          { data: ARRAY_NAME_COL[gCOL_NO] },
          { data: ARRAY_NAME_COL[gCOL_ORDERCODE] },
          { data: ARRAY_NAME_COL[gCOL_COMBO] },
          { data: ARRAY_NAME_COL[gCOL_PIZZA_ID] },
          { data: ARRAY_NAME_COL[gCOL_DRINK_ID] },
          { data: ARRAY_NAME_COL[gCOL_PRICE] },
          { data: ARRAY_NAME_COL[gCOL_CUSTOMER_NAME] },
          { data: ARRAY_NAME_COL[gCOL_PHONE] },
          { data: ARRAY_NAME_COL[gCOL_STATUS] },
          { data: ARRAY_NAME_COL[gCOL_ACTION] },
        ],
        columnDefs: [
          //định nghĩa các cột cần hiện ra
          {
            targets: gCOL_NO, //cột STT
            className: "text-center text-primary",
            /*render: function (data, type, row, meta) {
                            return meta.row + meta.settings._iDisplayStart + 1; */
            render: function () {
              gStt++;
              return gStt;
            },
          },
          {
            targets: gCOL_ACTION, //cột Action
            className: "text-center",
            defaultContent: `
                            <button id= "edit-order"  <i title = 'DEATIL' class="fa-solid fa-file-circle-check text-info" style = "cursor:pointer; border: 1px white;"></i></button> &nbsp; 
                            <button id= "delete-order" <i title = 'Delete' class="fa-solid fa-trash text-danger" style = "cursor:pointer;border: 1px white;"></i></button>`,
          },
        ],
      });

      /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
      onPageLoading();
      //gọi hàm hiển thị danh sách đồi uống vào select (trong modal)
      getDrinkList();
      //gọi hàm hiển thị kích cỡ pizza select(trong modal)
      getPizzaSize(gPizzaSize);
      //thêm sự kiện cho nút filter
      $("#btn-filter-order").on("click", function () {
        //gọi hàm thực thi filter
        onBtnFilterOrderClick();
      });

      //gán sự kiện tạo order mới
      $("#add-infor-order").on("click", function () {
        onBtnAddInforOrderClick();
      });
      // gán sự kiện cho nút Confirm create (trên modal)
      $("#btn-create-confirm").on("click", function () {
        onBtnConfirmCreateOrderClick();
      });
      // gán sự kiện cho nút Cancel (trên modal)
      $("#btn-create-close").on("click", function () {
        onBtnCloseCreateOrderClick();
      });

      // 3 - U: gán sự kiện Update - khi nhấn nút edit
      $("#order-table").on("click", "#edit-order", function () {
        onBtnEditClick(this);
      });
      // gán sự kiện cho nút Confirm edit (trên modal)
      $("#btn-edit-confirm").on("click", function () {
        onBtnConfirmEditOrderClick();
      });
      // gán sự kiện cho nút Cancel (trên modal)
      $("#btn-edit-cancel").on("click", function () {
        onBtnCancelEditOrderClick();
      });

      $("#order-table").on("click", "#delete-order", function () {
        onBtnDeleteOrderClick(this);
      });
      // gán sự kiện cho nút Confirm edit (trên modal)
      $("#btn-delete-confirm").on("click", function () {
        onBtnConfirmDeleteOrderClick();
      });
      // gán sự kiện cho nút Cancel (trên modal)
      $("#btn-delete-cancel").on("click", function () {
        onBtnCancelDeleteOrderClick();
      });

      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      function onPageLoading() {
        "use strict";
        loadDataToPizzaTypeSelect(gPizzaType);
        loadDataToStatusSelect(gStatus);
        // lấy data từ server
        callApiToGetOrder();
      }

      //hàm call API to get all order
      function callApiToGetOrder() {
        $.ajax({
          url: gBASE_URL,
          type: "GET",
          dataType: "json",
          success: function (responseObject) {
            gOrderObjects = responseObject;
            DisplayOrderToTable(responseObject);
          },
          error: function (error) {
            console.assert(error.responseText);
          },
        });
      }

      //hàm xử lý nút filter
      function onBtnFilterOrderClick() {
        ("use strict");
        //khai báo đối tượng chứa dữ liệu filter
        var vFilterPizzaType = {
          status: "",
          pizzaTypeId: "",
        };
        //B1 thu thập dữ liệu để filter
        getFilterFormData(vFilterPizzaType);
        //B2: validate (k cần)
        //B3: xử lý filter
        var vResultFilter = filterPizzaType(vFilterPizzaType);
        console.log(vResultFilter);
        //B4 hiển thị kết quả lọc
        if (vResultFilter.length > 0) {
          //hiện thông báo đã tìm được
          alert("Found " + vResultFilter.length + " results");
          //hiển thị danh sách dữ liệu tìm được ra table
          DisplayOrderToTable(vResultFilter);
        } else {
          alert("No result was found");
          return false;
        }
      }

      //hàm xử lý sự kiện add infor order
      function onBtnAddInforOrderClick() {
        "use strict";
        console.log("Button add được click");
        $("#create-order-modal").modal("show");
      }
      // Hàm xử lý sự kiện khi icon close trên bảng đc click
      function onBtnCloseCreateOrderClick() {
        "use strict";
        $("#create-order-modal").modal("hide");
      }

      //Hàm xử lý khi nhấn nút confirm trên modal
      function onBtnConfirmCreateOrderClick() {
        // khai báo đối tượng chứa user data
        var vObjectDataOrder = {
          orderCode: "",
          kichCo: "",
          duongKinh: "",
          suon: "",
          salad: "",
          loaiPizza: "",
          idVourcher: "",
          thanhTien: "",
          giamGia: "",
          idLoaiNuocUong: "",
          soLuongNuoc: "",
          hoTen: "",
          email: "",
          soDienThoai: "",
          diaChi: "",
          loiNhan: "",
          trangThai: "",
          ngayTao: "",
          ngayCapNhat: "",
        };

        // B1: Thu thập dữ liệu
        getCreateOrderData(vObjectDataOrder);
        // B2: Validate update
        var vIsValidate = validateData(vObjectDataOrder);
        if (vIsValidate) {
          // B3: update order
          $.ajax({
            url: gBASE_URL,
            type: "POST",
            contentType: "application/json;charset=UTF-8",
            data: JSON.stringify(vObjectDataOrder),
            success: function (paramRes) {
              // B4: xử lý front-end
              handleCreateOrderSuccess();
            },
            error: function (paramErr) {
              console.log(paramErr.status);
            },
          });
        }
      }

      // Hàm xử lý sự kiện khi icon edit trên bảng đc click
      function onBtnEditClick(paramBtnEdit) {
        "use strict";
        console.log("Button edit được click");
        // hàm dựa vào button edit (edit or delete) xác định đc id
        var vTableRow = $(paramBtnEdit).parents("tr");
        var vOrderRowData = gOrderTable.row(vTableRow).data();
        gId = vOrderRowData.id;
        gOrderCode = vOrderRowData.orderCode;

        console.log("ID lấy được: " + gId);
        console.log("Order code lấy được: " + gOrderCode);
        getOrderByCode(gOrderCode);
      }

      //Hàm xử lý khi nhấn nút confirm trên modal
      function onBtnConfirmEditOrderClick() {
        // khai báo đối tượng chứa user data
        var vObjectDataOrder = {
          orderCode: "",
          kichCo: "",
          duongKinh: "",
          suon: "",
          salad: "",
          loaiPizza: "",
          idVourcher: "",
          thanhTien: "",
          giamGia: "",
          idLoaiNuocUong: "",
          soLuongNuoc: "",
          hoTen: "",
          email: "",
          soDienThoai: "",
          diaChi: "",
          loiNhan: "",
          trangThai: "",
          ngayTao: "",
          ngayCapNhat: "",
        };

        // B1: Thu thập dữ liệu
        getEditOrderData(vObjectDataOrder);
        // B2: Validate update
        var vIsValidate = validateData(vObjectDataOrder);
        if (vIsValidate) {
          // B3: update order
          $.ajax({
            url: gBASE_URL + "/" + gId,
            type: "PUT",
            contentType: "application/json;charset=UTF-8",
            data: JSON.stringify(vObjectDataOrder),
            success: function (paramRes) {
              // B4: xử lý front-end
              handleUpdateOrderSuccess();
            },
            error: function (paramErr) {
              console.log(paramErr.status);
            },
          });
        }
      }

      //Hàm xử lý khi nhấn nút cancel trên modal
      function onBtnCancelEditOrderClick() {
        // khai báo đối tượng chứa user data
        var vObjectDataOrder = {
          trangThai: "cancel",
          ngayCapNhat: "",
        };

        // B1: Thu thập dữ liệu
        // B2: Validate update
        // B3: Update status to Cancel order
        $.ajax({
          url: gBASE_URL + "/" + gId,
          type: "PUT",
          contentType: "application/json;charset=UTF-8",
          data: JSON.stringify(vObjectDataOrder),
          success: function (paramRes) {
            // B4: xử lý front-end
            handleCancelOrderSuccess();
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          },
        });
      }

      // Hàm xử lý sự kiện khi icon delete trên bảng đc click
      function onBtnDeleteOrderClick(paramBtnDelete) {
        "use strict";
        console.log("Button delete được click");
        // hàm dựa vào button detail (edit or delete) xác định đc id
        var vTableRow = $(paramBtnDelete).parents("tr");
        var vOrderRowData = gOrderTable.row(vTableRow).data();
        gId = vOrderRowData.id;
        console.log("ID lấy được: " + gId);
        // hiển thị modal lên
        $("#delete-order-modal").modal("show");
      }

      //sự kiện confirm delete order
      function onBtnConfirmDeleteOrderClick() {
        deleteOrderById(gId);
      }
      //cancel delete order
      function onBtnCancelDeleteOrderClick() {
        $("#delete-order-modal").modal("hide");
      }
      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      //hàm thu thập dữ liệu để lọc
      function getFilterFormData(paramFilterObj) {
        "use strict";
        paramFilterObj.pizzaTypeId = $("#select-typePizza").val();
        paramFilterObj.status = $("#select-status").val();
        console.log(
          "Pizza type đã lọc là: " +
            paramFilterObj.pizzaTypeId +
            " + Status: " +
            paramFilterObj.status
        );
      }

      //hàm thực hiện lọc và hiển thị lên table
      function filterPizzaType(paramFilterObj) {
        var vResult = [];
        //thực hiện lọc
        vResult = gOrderObjects.filter(function (paramOrder) {
          if (paramOrder.loaiPizza != null) {
            return (
              (paramFilterObj.pizzaTypeId === "All" ||
                paramOrder.loaiPizza.toLowerCase() ===
                  paramFilterObj.pizzaTypeId.toLowerCase()) &&
              (paramFilterObj.status === "All" ||
                paramOrder.trangThai.toLowerCase() ===
                  paramFilterObj.status.toLowerCase())
            );
          }
        });

        return vResult;
      }

      //hàm load dữ liệu vào user table
      function DisplayOrderToTable(paramData) {
        "use strict";
        gSTT = 1; // thiết lập lại stt
        $("#order-table").DataTable().clear(); // xóa dữ liệu
        $("#order-table").DataTable().rows.add(paramData); //thêm các dòng dữ liệu vào datatable
        $("#order-table").DataTable().draw(); //vẽ lại bảng
      }

      // hàm get voucher by id
      function getOrderByCode(paramOrderCode) {
        $.ajax({
          url: gBASE_URL + "/" + gOrderCode,
          type: "GET",
          success: function (paramOrderRes) {
            showOrderDataToModal(paramOrderRes);
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          },
        });
        // hiển thị modal lên
        $("#edit-order-modal").modal("show");
      }

      // hàm show order obj lên modal
      function showOrderDataToModal(paramOrderObj) {
        $("#input-edit-order-code").val(paramOrderObj.orderCode);
        $("#edit-select-combo").val(paramOrderObj.kichCo);
        $("#edit-size-cm").val(paramOrderObj.duongKinh);
        $("#edit-ribs").val(paramOrderObj.suon);
        $("#edit-salad").val(paramOrderObj.salad);
        $("#edit-pizza-type").val(paramOrderObj.loaiPizza);
        $("#edit-voucher").val(paramOrderObj.idVourcher);
        $("#edit-price").val(paramOrderObj.thanhTien);
        $("#edit-discount").val(paramOrderObj.giamGia);
        $("#edit-drink").val(paramOrderObj.idLoaiNuocUong);
        $("#edit-amount").val(paramOrderObj.soLuongNuoc);
        $("#edit-fullname").val(paramOrderObj.hoTen);
        $("#edit-email").val(paramOrderObj.email);
        $("#edit-phone").val(paramOrderObj.soDienThoai);
        $("#edit-address").val(paramOrderObj.diaChi);
        $("#edit-message").val(paramOrderObj.loiNhan);
        $("#edit-order-date").val(paramOrderObj.ngayTao);
        $("#edit-update-date").val(paramOrderObj.ngayCapNhat);
      }

      // hàm thu thập dữ liệu để update order
      function getCreateOrderData(paramOrderObj) {
        paramOrderObj.orderCode = $("#input-create-order-code").val().trim();
        paramOrderObj.kichCo = $("#create-select-combo").val();
        paramOrderObj.duongKinh = parseInt($("#create-size-cm").val());
        paramOrderObj.suon = parseInt($("#create-ribs").val());
        paramOrderObj.salad = $("#create-salad").val();
        paramOrderObj.loaiPizza = $("#create-pizza-type").val();
        paramOrderObj.idVourcher = $("#create-voucher").val().trim();
        paramOrderObj.thanhTien = parseInt($("#create-price").val());
        paramOrderObj.giamGia = $("#create-discount").val().trim();
        paramOrderObj.idLoaiNuocUong = $("#create-drink").val();
        paramOrderObj.soLuongNuoc = parseInt($("#create-amount").val().trim());
        paramOrderObj.hoTen = $("#create-fullname").val();
        paramOrderObj.email = $("#create-email").val().trim();
        paramOrderObj.soDienThoai = $("#create-phone").val().trim();
        paramOrderObj.diaChi = $("#create-address").val().trim();
        paramOrderObj.loiNhan = $("#create-message").val();
        paramOrderObj.trangThai = "open";
        paramOrderObj.ngayTao = $("#create-order-date").val().trim();
        paramOrderObj.ngayCapNhat = $("#create-update-date").val().trim();
      }

      // hàm thu thập dữ liệu để update order
      function getEditOrderData(paramOrderObj) {
        paramOrderObj.orderCode = $("#input-edit-order-code").val().trim();
        paramOrderObj.kichCo = $("#edit-select-combo").val();
        paramOrderObj.duongKinh = parseInt($("#edit-size-cm").val());
        paramOrderObj.suon = parseInt($("#edit-ribs").val());
        paramOrderObj.salad = $("#edit-salad").val();
        paramOrderObj.loaiPizza = $("#edit-pizza-type").val();
        paramOrderObj.idVourcher = $("#edit-voucher").val().trim();
        paramOrderObj.thanhTien = parseInt($("#edit-price").val());
        paramOrderObj.giamGia = $("#edit-discount").val().trim();
        paramOrderObj.idLoaiNuocUong = $("#edit-drink").val();
        paramOrderObj.soLuongNuoc = parseInt($("#edit-amount").val().trim());
        paramOrderObj.hoTen = $("#edit-fullname").val();
        paramOrderObj.email = $("#edit-email").val().trim();
        paramOrderObj.soDienThoai = $("#edit-phone").val().trim();
        paramOrderObj.diaChi = $("#edit-address").val().trim();
        paramOrderObj.loiNhan = $("#edit-message").val();
        paramOrderObj.trangThai = "confirmed";
        paramOrderObj.ngayTao = $("#edit-order-date").val().trim();
        paramOrderObj.ngayCapNhat = $("#edit-update-date").val().trim();
      }

      // hàm validate data
      function validateData(paramOrderObj) {
        if (paramOrderObj.orderCode === "") {
          alert("Please input Order code");
          return false;
        }
        if (paramOrderObj.kichCo === "all") {
          alert("Please select Combo");
          return false;
        }
        if (paramOrderObj.thanhTien < 0 || paramOrderObj.thanhTien == 0) {
          alert("Price must be greater than 0");
          return false;
        }
        if (paramOrderObj.idLoaiNuocUong === "all") {
          alert("Please select Drink");
          return false;
        }

        return true;
      }

      //hàm confirm create thành công
      function handleCreateOrderSuccess() {
        alert("Confirmed create order successfully!");
        callApiToGetOrder();
        resertCreateOrderForm();
        $("#create-order-modal").modal("hide");
      }

      //hàm confirm edit thành công
      function handleUpdateOrderSuccess() {
        alert("Confirmed order successfully!");
        callApiToGetOrder();
        resertEditOrderForm();
        $("#edit-order-modal").modal("hide");
      }

      //hàm cancel thành công
      function handleCancelOrderSuccess() {
        alert("Canceled order successfully!");
        callApiToGetOrder();
        resertEditOrderForm();
        $("#edit-order-modal").modal("hide");
      }

      // hàm xóa trắng form edit modal
      function resertCreateOrderForm() {
        $("#input-create-order-code").val("");
        $("#create-select-combo").val("");
        $("#create-size-cm").val("");
        $("#create-ribs").val("");
        $("#create-salad").val("");
        $("#create-pizza-type").val("");
        $("#create-voucher").val("");
        $("#create-price").val("");
        $("#create-discount").val("");
        $("#create-drink").val("");
        $("#create-amount").val("");
        $("#create-fullname").val("");
        $("#create-email").val("");
        $("#create-phone").val("");
        $("#create-address").val("");
        $("#create-message").val("");
        $("#create-order-date").val("");
        $("#create-update-date").val("");
      }

      // hàm xóa trắng form edit modal
      function resertEditOrderForm() {
        $("#input-edit-order-code").val("");
        $("#edit-select-combo").val("");
        $("#edit-size-cm").val("");
        $("#edit-ribs").val("");
        $("#edit-salad").val("");
        $("#edit-pizza-type").val("");
        $("#edit-voucher").val("");
        $("#edit-price").val("");
        $("#edit-discount").val("");
        $("#edit-drink").val("");
        $("#edit-amount").val("");
        $("#edit-fullname").val("");
        $("#edit-email").val("");
        $("#edit-phone").val("");
        $("#edit-address").val("");
        $("#edit-message").val("");
        $("#edit-order-date").val("");
        $("#edit-update-date").val("");
      }

      //hàm load dữ liệu pizza type select
      function loadDataToPizzaTypeSelect(paramData) {
        "use strict";
        $("#select-typePizza").append(
          $("<option>", {
            text: "All",
            value: "All",
          })
        );

        for (var bI = 0; bI < paramData.length; bI++) {
          $("#select-typePizza").append(
            $("<option>", {
              text: paramData[bI].typeName,
              value: paramData[bI].typeId,
            })
          );
        }
      }

      //hàm load dữ liệu status select
      function loadDataToStatusSelect(paramData) {
        "use strict";
        $("#select-status").append(
          $("<option>", {
            text: "All",
            value: "All",
          })
        );

        for (var bI = 0; bI < paramData.length; bI++) {
          $("#select-status").append(
            $("<option>", {
              text: paramData[bI].name,
              value: paramData[bI].id,
            })
          );
        }
      }

      //hàm gọi API select drink
      function getDrinkList() {
        "use strict";
        $.ajax({
          url: "http://203.171.20.210:8080/devcamp-pizza365/drinks",
          dataType: "json",
          type: "GET",
          success: function (paramRes) {
            console.log(paramRes);
            handleDrinkList(paramRes);
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          },
        });
      }

      //hàm tạo option cho select drink
      function handleDrinkList(paramDrink) {
        "use strict";
        for (var bI = 0; bI < paramDrink.length; bI++) {
          $("#create-drink").append(
            $("<option>", {
              text: paramDrink[bI].tenNuocUong,
              value: paramDrink[bI].maNuocUong,
            })
          );
        }
        for (var bI = 0; bI < paramDrink.length; bI++) {
          $("#edit-drink").append(
            $("<option>", {
              text: paramDrink[bI].tenNuocUong,
              value: paramDrink[bI].maNuocUong,
            })
          );
        }
      }

      //hàm tạo option cho select size
      function getPizzaSize(paramPizza) {
        "use strict";
        for (var bI = 0; bI < paramPizza.length; bI++) {
          $("#create-select-combo").append(
            $("<option>", {
              text: paramPizza[bI],
              value: paramPizza[bI],
            })
          );
        }
        for (var bI = 0; bI < paramPizza.length; bI++) {
          $("#edit-select-combo").append(
            $("<option>", {
              text: paramPizza[bI],
              value: paramPizza[bI],
            })
          );
        }
      }

      // hàm get order by id
      function deleteOrderById(paramOrderId) {
        $.ajax({
          url: gBASE_URL + "/" + paramOrderId,
          type: "DELETE",
          async: false,
          success: function (paramOrderRes) {
            console.log(paramOrderRes);
            handleDeleteOrderSuccess();
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          },
        });
      }

      //hàm confirm delete thành công
      function handleDeleteOrderSuccess() {
        alert("Delete order successfully!");
        callApiToGetOrder();
        resertEditOrderForm();
        $("#delete-order-modal").modal("hide");
      }
    </script>
  </body>
</html>
